Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 50892)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 50893)
@@ -2,5 +2,4 @@
     <qresource prefix="/">
         <file alias="tpixel.png">images/tpixel.png</file>
-        <file alias="transparent_16px.png">images/transparent_16px.png</file>
         <file alias="vm_delete_32px.png">images/vm_delete_32px.png</file>
         <file alias="vm_delete_disabled_32px.png">images/vm_delete_disabled_32px.png</file>
@@ -9,5 +8,4 @@
         <file alias="vm_add_16px.png">images/vm_add_16px.png</file>
         <file alias="vm_new_32px.png">images/vm_new_32px.png</file>
-        <file alias="vm_new_disabled_32px.png">images/vm_new_disabled_32px.png</file>
         <file alias="vm_pause_32px.png">images/vm_pause_32px.png</file>
         <file alias="vm_pause_disabled_32px.png">images/vm_pause_disabled_32px.png</file>
@@ -46,6 +44,4 @@
         <file alias="machine_24px.png">images/machine_24px.png</file>
         <file alias="machine_32px.png">images/machine_32px.png</file>
-        <file alias="machine_disabled_16px.png">images/machine_disabled_16px.png</file>
-        <file alias="machine_disabled_32px.png">images/machine_disabled_32px.png</file>
         <file alias="help_16px.png">images/help_16px.png</file>
         <file alias="help_button_normal_mac_22px.png">images/help_button_normal_mac_22px.png</file>
@@ -54,9 +50,4 @@
         <file alias="site_24px.png">images/site_24px.png</file>
         <file alias="site_32px.png">images/site_32px.png</file>
-        <file alias="site_disabled_16px.png">images/site_disabled_16px.png</file>
-        <file alias="site_disabled_32px.png">images/site_disabled_32px.png</file>
-        <file alias="register_16px.png">images/register_16px.png</file>
-        <file alias="register_32px.png">images/register_32px.png</file>
-        <file alias="register_disabled_16px.png">images/register_disabled_16px.png</file>
         <file alias="vm_reset_16px.png">images/vm_reset_16px.png</file>
         <file alias="vm_reset_disabled_16px.png">images/vm_reset_disabled_16px.png</file>
@@ -74,5 +65,4 @@
         <file alias="auto_resize_on_on_disabled_16px.png">images/auto_resize_on_on_disabled_16px.png</file>
         <file alias="auto_resize_off_16px.png">images/auto_resize_off_16px.png</file>
-        <file alias="auto_resize_off_disabled_16px.png">images/auto_resize_off_disabled_16px.png</file>
         <file alias="exit_16px.png">images/exit_16px.png</file>
         <file alias="vm_poweroff_16px.png">images/vm_poweroff_16px.png</file>
@@ -82,5 +72,4 @@
         <file alias="diskimage_16px.png">images/diskimage_16px.png</file>
         <file alias="diskimage_32px.png">images/diskimage_32px.png</file>
-        <file alias="diskimage_disabled_32px.png">images/diskimage_disabled_32px.png</file>
         <file alias="vm_settings_16px.png">images/vm_settings_16px.png</file>
         <file alias="vm_settings_disabled_16px.png">images/vm_settings_disabled_16px.png</file>
@@ -95,10 +84,8 @@
         <file alias="sound_24px.png">images/sound_24px.png</file>
         <file alias="sound_32px.png">images/sound_32px.png</file>
-        <file alias="sound_disabled_32px.png">images/sound_disabled_32px.png</file>
         <file alias="nw_16px.png">images/nw_16px.png</file>
         <file alias="nw_24px.png">images/nw_24px.png</file>
         <file alias="nw_32px.png">images/nw_32px.png</file>
         <file alias="nw_disabled_16px.png">images/nw_disabled_16px.png</file>
-        <file alias="nw_disabled_32px.png">images/nw_disabled_32px.png</file>
         <file alias="nw_read_16px.png">images/nw_read_16px.png</file>
         <file alias="nw_write_16px.png">images/nw_write_16px.png</file>
@@ -107,5 +94,4 @@
         <file alias="usb_32px.png">images/usb_32px.png</file>
         <file alias="usb_disabled_16px.png">images/usb_disabled_16px.png</file>
-        <file alias="usb_disabled_32px.png">images/usb_disabled_32px.png</file>
         <file alias="usb_new_16px.png">images/usb_new_16px.png</file>
         <file alias="usb_new_disabled_16px.png">images/usb_new_disabled_16px.png</file>
@@ -122,6 +108,4 @@
         <file alias="usb_remove_16px.png">images/usb_remove_16px.png</file>
         <file alias="usb_remove_disabled_16px.png">images/usb_remove_disabled_16px.png</file>
-        <file alias="usb_unavailable_16px.png">images/usb_unavailable_16px.png</file>
-        <file alias="usb_unavailable_disabled_16px.png">images/usb_unavailable_disabled_16px.png</file>
         <file alias="usb_collapse_16px.png">images/usb_collapse_16px.png</file>
         <file alias="usb_expand_16px.png">images/usb_expand_16px.png</file>
@@ -129,33 +113,13 @@
         <file alias="parallel_port_24px.png">images/parallel_port_24px.png</file>
         <file alias="parallel_port_32px.png">images/parallel_port_32px.png</file>
-        <file alias="parallel_port_disabled_16px.png">images/parallel_port_disabled_16px.png</file>
-        <file alias="parallel_port_disabled_32px.png">images/parallel_port_disabled_32px.png</file>
-        <file alias="parallel_port_read_16px.png">images/parallel_port_read_16px.png</file>
-        <file alias="parallel_port_write_16px.png">images/parallel_port_write_16px.png</file>
         <file alias="serial_port_16px.png">images/serial_port_16px.png</file>
         <file alias="serial_port_24px.png">images/serial_port_24px.png</file>
         <file alias="serial_port_32px.png">images/serial_port_32px.png</file>
-        <file alias="serial_port_disabled_16px.png">images/serial_port_disabled_16px.png</file>
-        <file alias="serial_port_disabled_32px.png">images/serial_port_disabled_32px.png</file>
-        <file alias="serial_port_read_16px.png">images/serial_port_read_16px.png</file>
-        <file alias="serial_port_write_16px.png">images/serial_port_write_16px.png</file>
         <file alias="select_file_16px.png">images/select_file_16px.png</file>
         <file alias="select_file_disabled_16px.png">images/select_file_disabled_16px.png</file>
         <file alias="list_moveup_16px.png">images/list_moveup_16px.png</file>
-        <file alias="list_moveup_22px.png">images/list_moveup_22px.png</file>
         <file alias="list_moveup_disabled_16px.png">images/list_moveup_disabled_16px.png</file>
-        <file alias="list_moveup_disabled_22px.png">images/list_moveup_disabled_22px.png</file>
         <file alias="list_movedown_16px.png">images/list_movedown_16px.png</file>
-        <file alias="list_movedown_22px.png">images/list_movedown_22px.png</file>
         <file alias="list_movedown_disabled_16px.png">images/list_movedown_disabled_16px.png</file>
-        <file alias="list_movedown_disabled_22px.png">images/list_movedown_disabled_22px.png</file>
-        <file alias="discard_cur_state_16px.png">images/discard_cur_state_16px.png</file>
-        <file alias="discard_cur_state_22px.png">images/discard_cur_state_22px.png</file>
-        <file alias="discard_cur_state_dis_16px.png">images/discard_cur_state_dis_16px.png</file>
-        <file alias="discard_cur_state_dis_22px.png">images/discard_cur_state_dis_22px.png</file>
-        <file alias="discard_cur_state_snapshot_16px.png">images/discard_cur_state_snapshot_16px.png</file>
-        <file alias="discard_cur_state_snapshot_22px.png">images/discard_cur_state_snapshot_22px.png</file>
-        <file alias="discard_cur_state_snapshot_dis_16px.png">images/discard_cur_state_snapshot_dis_16px.png</file>
-        <file alias="discard_cur_state_snapshot_dis_22px.png">images/discard_cur_state_snapshot_dis_22px.png</file>
         <file alias="snapshot_take_16px.png">images/snapshot_take_16px.png</file>
         <file alias="snapshot_take_22px.png">images/snapshot_take_22px.png</file>
@@ -186,5 +150,4 @@
         <file alias="sf_32px.png">images/sf_32px.png</file>
         <file alias="sf_disabled_16px.png">images/sf_disabled_16px.png</file>
-        <file alias="sf_disabled_32px.png">images/sf_disabled_32px.png</file>
         <file alias="sf_read_16px.png">images/sf_read_16px.png</file>
         <file alias="sf_write_16px.png">images/sf_write_16px.png</file>
@@ -196,5 +159,4 @@
         <file alias="remove_host_iface_disabled_16px.png">images/remove_host_iface_disabled_16px.png</file>
         <file alias="eraser_16px.png">images/eraser_16px.png</file>
-        <file alias="eraser_disabled_16px.png">images/eraser_disabled_16px.png</file>
         <file alias="refresh_16px.png">images/refresh_16px.png</file>
         <file alias="refresh_22px.png">images/refresh_22px.png</file>
@@ -206,23 +168,15 @@
         <file alias="vm_show_logs_16px.png">images/vm_show_logs_16px.png</file>
         <file alias="vm_show_logs_disabled_16px.png">images/vm_show_logs_disabled_16px.png</file>
-        <file alias="vm_show_logs_22px.png">images/vm_show_logs_22px.png</file>
-        <file alias="vm_show_logs_disabled_22px.png">images/vm_show_logs_disabled_22px.png</file>
         <file alias="description_16px.png">images/description_16px.png</file>
-        <file alias="description_disabled_16px.png">images/description_disabled_16px.png</file>
-        <file alias="description_edit_16px.png">images/description_edit_16px.png</file>
-        <file alias="description_edit_disabled_16px.png">images/description_edit_disabled_16px.png</file>
         <file alias="session_info_16px.png">images/session_info_16px.png</file>
         <file alias="session_info_disabled_16px.png">images/session_info_disabled_16px.png</file>
         <file alias="session_info_32px.png">images/session_info_32px.png</file>
-        <file alias="session_info_disabled_32px.png">images/session_info_disabled_32px.png</file>
         <file alias="session_info_details_16px.png">images/session_info_details_16px.png</file>
         <file alias="session_info_runtime_16px.png">images/session_info_runtime_16px.png</file>
         <file alias="global_settings_16px.png">images/global_settings_16px.png</file>
-        <file alias="global_settings_disabled_16px.png">images/global_settings_disabled_16px.png</file>
         <file alias="vrdp_16px.png">images/vrdp_16px.png</file>
         <file alias="vrdp_24px.png">images/vrdp_24px.png</file>
         <file alias="vrdp_32px.png">images/vrdp_32px.png</file>
         <file alias="vrdp_disabled_16px.png">images/vrdp_disabled_16px.png</file>
-        <file alias="vrdp_disabled_32px.png">images/vrdp_disabled_32px.png</file>
         <file alias="vrdp_on_16px.png">images/vrdp_on_16px.png</file>
         <file alias="vrdp_on_disabled_16px.png">images/vrdp_on_disabled_16px.png</file>
@@ -264,6 +218,4 @@
         <file alias="chipset_24px.png">images/chipset_24px.png</file>
         <file alias="chipset_32px.png">images/chipset_32px.png</file>
-        <file alias="chipset_disabled_16px.png">images/chipset_disabled_16px.png</file>
-        <file alias="chipset_disabled_32px.png">images/chipset_disabled_32px.png</file>
         <file alias="pin_16px.png">images/pin_16px.png</file>
         <file alias="minimize_16px.png">images/minimize_16px.png</file>
@@ -280,5 +232,4 @@
         <file alias="video_capture_on_disabled_16px.png">images/video_capture_on_disabled_16px.png</file>
         <file alias="video_capture_settings_16px.png">images/video_capture_settings_16px.png</file>
-        <file alias="video_capture_write_16px.png">images/video_capture_write_16px.png</file>
         <file alias="drag_drop_16px.png">images/drag_drop_16px.png</file>
         <file alias="drag_drop_disabled_16px.png">images/drag_drop_disabled_16px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 50892)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 50893)
@@ -77,5 +77,4 @@
         <file alias="hd_32px.png">images/hd_32px.png</file>
         <file alias="hd_disabled_16px.png">images/hd_disabled_16px.png</file>
-        <file alias="hd_disabled_32px.png">images/hd_disabled_32px.png</file>
         <file alias="hd_settings_16px.png">images/hd_settings_16px.png</file>
         <file alias="hd_settings_disabled_16px.png">images/hd_settings_disabled_16px.png</file>
@@ -84,6 +83,4 @@
         <file alias="hd_add_16px.png">images/hd_add_16px.png</file>
         <file alias="hd_add_disabled_16px.png">images/hd_add_disabled_16px.png</file>
-        <file alias="hd_add_22px.png">images/hd_add_22px.png</file>
-        <file alias="hd_add_disabled_22px.png">images/hd_add_disabled_22px.png</file>
         <file alias="hd_copy_16px.png">images/hd_copy_16px.png</file>
         <file alias="hd_copy_disabled_16px.png">images/hd_copy_disabled_16px.png</file>
@@ -96,6 +93,4 @@
         <file alias="hd_new_16px.png">images/hd_new_16px.png</file>
         <file alias="hd_new_disabled_16px.png">images/hd_new_disabled_16px.png</file>
-        <file alias="hd_new_22px.png">images/hd_new_22px.png</file>
-        <file alias="hd_new_disabled_22px.png">images/hd_new_disabled_22px.png</file>
         <file alias="hd_release_16px.png">images/hd_release_16px.png</file>
         <file alias="hd_release_disabled_16px.png">images/hd_release_disabled_16px.png</file>
@@ -108,6 +103,4 @@
         <file alias="cd_16px.png">images/cd_16px.png</file>
         <file alias="cd_disabled_16px.png">images/cd_disabled_16px.png</file>
-        <file alias="cd_32px.png">images/cd_32px.png</file>
-        <file alias="cd_disabled_32px.png">images/cd_disabled_32px.png</file>
         <file alias="cd_read_16px.png">images/cd_read_16px.png</file>
         <file alias="cd_write_16px.png">images/cd_write_16px.png</file>
@@ -118,6 +111,4 @@
         <file alias="fd_16px.png">images/fd_16px.png</file>
         <file alias="fd_disabled_16px.png">images/fd_disabled_16px.png</file>
-        <file alias="fd_32px.png">images/fd_32px.png</file>
-        <file alias="fd_disabled_32px.png">images/fd_disabled_32px.png</file>
         <file alias="fd_read_16px.png">images/fd_read_16px.png</file>
         <file alias="fd_write_16px.png">images/fd_write_16px.png</file>
@@ -138,5 +129,4 @@
         <file alias="hostkey_32px.png">images/hostkey_32px.png</file>
         <file alias="hostkey_disabled_16px.png">images/hostkey_disabled_16px.png</file>
-        <file alias="hostkey_disabled_32px.png">images/hostkey_disabled_32px.png</file>
         <file alias="hostkey_pressed_16px.png">images/hostkey_pressed_16px.png</file>
         <file alias="hostkey_captured_16px.png">images/hostkey_captured_16px.png</file>
@@ -158,6 +148,4 @@
         <file alias="controller_remove_16px.png">images/controller_remove_16px.png</file>
         <file alias="controller_remove_disabled_16px.png">images/controller_remove_disabled_16px.png</file>
-        <file alias="attachment_16px.png">images/attachment_16px.png</file>
-        <file alias="attachment_disabled_16px.png">images/attachment_disabled_16px.png</file>
         <file alias="attachment_add_16px.png">images/attachment_add_16px.png</file>
         <file alias="attachment_add_disabled_16px.png">images/attachment_add_disabled_16px.png</file>
@@ -184,25 +172,13 @@
         <file alias="progress_dnd_hg_90px.png">images/progress_dnd_hg_90px.png</file>
         <file alias="status_check_16px.png">images/status_check_16px.png</file>
-        <file alias="status_check_32px.png">images/status_check_32px.png</file>
         <file alias="status_error_16px.png">images/status_error_16px.png</file>
-        <file alias="status_error_32px.png">images/status_error_32px.png</file>
-        <file alias="extension_pack_16px.png">images/extension_pack_16px.png</file>
         <file alias="extension_pack_24px.png">images/extension_pack_24px.png</file>
         <file alias="extension_pack_32px.png">images/extension_pack_32px.png</file>
-        <file alias="extension_pack_disabled_16px.png">images/extension_pack_disabled_16px.png</file>
-        <file alias="extension_pack_disabled_32px.png">images/extension_pack_disabled_32px.png</file>
         <file alias="extension_pack_install_16px.png">images/extension_pack_install_16px.png</file>
         <file alias="extension_pack_install_disabled_16px.png">images/extension_pack_install_disabled_16px.png</file>
-        <file alias="extension_pack_install_32px.png">images/extension_pack_install_32px.png</file>
-        <file alias="extension_pack_install_disabled_32px.png">images/extension_pack_install_disabled_32px.png</file>
         <file alias="extension_pack_uninstall_16px.png">images/extension_pack_uninstall_16px.png</file>
         <file alias="extension_pack_uninstall_disabled_16px.png">images/extension_pack_uninstall_disabled_16px.png</file>
-        <file alias="extension_pack_uninstall_32px.png">images/extension_pack_uninstall_32px.png</file>
-        <file alias="extension_pack_uninstall_disabled_32px.png">images/extension_pack_uninstall_disabled_32px.png</file>
-        <file alias="proxy_16px.png">images/proxy_16px.png</file>
         <file alias="proxy_24px.png">images/proxy_24px.png</file>
         <file alias="proxy_32px.png">images/proxy_32px.png</file>
-        <file alias="proxy_disabled_16px.png">images/proxy_disabled_16px.png</file>
-        <file alias="proxy_disabled_32px.png">images/proxy_disabled_32px.png</file>
         <file alias="nw_error_16px.png">images/nw_error_16px.png</file>
         <file alias="nw_loading_16px.png">images/nw_loading_16px.png</file>